package main

import (
	"encoding/json"
)

//Slice de Produto
type Cardápio []*Produto

// Constrói instância do objeto Cardápio
//Repare que é uma função e não um "método"!
func NovoCardápio(lista [][]string) Cardápio {

	var l []*Produto

	for _, v := range lista {

		l = append(l, &Produto{
			Código: parseInt(v[0]), Item: v[1], Preço: parseFloat(v[2]),
		})
	}

	return Cardápio(l)
}

//"Método" para fazer uma MarshalIndent em Cardápio 
func (c Cardápio) String() string {
	b, _ := json.MarshalIndent(c, "", " ")
	return string(b)
}

//Define objeto Produto
type Produto struct {
	Código int
	Item   string
	Preço  float64
}

//Sort
type ByCódigo Cardápio

func (a ByCódigo) Len() int           { return len(a) }
func (a ByCódigo) Swap(i, j int)      { a[i], a[j] = a[j], a[i] }
func (a ByCódigo) Less(i, j int) bool { return a[i].Código < a[j].Código }
