package main

import (
	"encoding/csv"
	"flag"
	"log"
	"os"
	"strconv"
)

var (
	entr string // Entregadores
	card string // Cardápio
)

func init() {
	flag.StringVar(&entr, "e", "", "arquivo .csv de entregadores")
	flag.StringVar(&card, "c", "", "arquivo .csv de cardápio")
	flag.Parse()
}

//Função que carrega os dados e faz a verificações necessárias
func CarregaDados() (ent Entregadores, car Cardápio) {

	if entr == "" || card == "" {
		log.Fatalln("Arquivos de entrada não especificados."+
			"Use: -e <entregadores>.csv -c <cardápio>.csv", card)
	}

	var Entr, Card [][]string

	if f, err := os.Open(entr); err == nil {
		r := csv.NewReader(f)
		r.Comma = ';'
		r.Read()
		Entr, _ = r.ReadAll()
		f.Close()
	} else {
		log.Fatalln("Não foi possível abrir o arquivo", entr)
	}
	ent = NovoEntregadores(Entr)

	if f, err := os.Open(card); err == nil {
		r := csv.NewReader(f)
		r.Comma = ';'
		r.Read()
		Card, _ = r.ReadAll()
		f.Close()
	} else {
		log.Fatalln("Não foi possível abrir o arquivo", card)
	}
	car = NovoCardápio(Card)

	return
}
//FIM





//Funções de auxílio
//Função para converter string em int
func parseInt(s string) int {
	i64, _ := strconv.ParseInt(s, 10, 0)
	return int(i64)
}
//Função para converter string em float64
func parseFloat(s string) (f float64) {
	f, _ = strconv.ParseFloat(s, 64)
	return
}
//FIM