package main

import (
	"encoding/json"
	"strconv"
)

//Slice de Entregador
type Entregadores []*Entregador

//"Método" para fazer uma MarshalIndent em Entregadores
func (e Entregadores) String() string {
	b, _ := json.MarshalIndent(e, "", "")
	return string(b)
}

//Objeto Entregador
type Entregador struct {
	Nome, Placa string
	Total float64
	Quantidade int
}

//Constrói instância do objeto Entregador
//Repare que é uma função e não um "método"!
func NovoEntregadores(lista [][]string) Entregadores {

	var l []*Entregador

	for _, v := range lista {
		l = append(l, &Entregador{v[0], v[1], 0, 0.0})
	}

	return Entregadores(l)
}

//"Método" para o calculo de venda de cada Entregador
func (entregador *Entregador) Venda(produto *Produto, quantidade string) {
	quant, _ := strconv.ParseFloat(quantidade, 64)
	entregador.Total = entregador.Total + produto.Preço*quant
} 

//Sort
type ByPlaca Entregadores

func (a ByPlaca ) Len() int           { return len(a) }
func (a ByPlaca ) Swap(i, j int)      { a[i], a[j] = a[j], a[i] }
func (a ByPlaca ) Less(i, j int) bool { return a[i].Placa < a[j].Placa }